package xyz.lychee.lagfixer.libs.adventure.text.format;

import xyz.lychee.lagfixer.libs.adventure.text.ComponentBuilder;
import xyz.lychee.lagfixer.libs.adventure.text.ComponentBuilderApplicable;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

@FunctionalInterface
public interface StyleBuilderApplicable extends ComponentBuilderApplicable {
   @Contract(
      mutates = "param"
   )
   void styleApply(final Style.@NotNull Builder style);

   default void componentBuilderApply(final @NotNull ComponentBuilder<?, ?> component) {
      component.style(this::styleApply);
   }
}
